#include <iostream>
#include <cmath>

using namespace std;
long long NZD(long long a, long long b)
{
    long long r=0;

    while(b != 0)
    {
        r = b;
        b = a % b;
        a = r;
    }

    return a;
}

int main()
{
    long long t, n, m, b=0;
    long long a=0, prosli=0, ciklus=0;

    cin >> t;

    for(int i=0; i < t; i++)
    {

        cin >> n >> m;
        ciklus = 0;
        a = 0;

        for(int j=0; j < n; j++)
        {
            prosli = a;
            cin >> a;
            if(j == 0)
            {
                continue;
            }
            if(j == 1)
            {
                ciklus = abs(a - prosli);
                continue;
            }
            ciklus = NZD(ciklus, abs(a - prosli));
        }

        long long k = a % ciklus;
        int ispis=1;

        for(int j=0; j < m; j++)
        {
            cin >> b;

            if(b % ciklus == k)
            {
                ispis = 0;
            }
        }
        cout << ispis << endl;
    }
    return 0;
}